/**
 * DevExtreme (client_exporter/xlsx/xlsx_fill_helper.js)
 * Version: 18.2.2-pre-beta
 * Build date: Fri Oct 19 2018
 *
 * Copyright (c) 2012 - 2018 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
var _type = require("../../core/utils/type");
var _xlsx_tag_helper = require("./xlsx_tag_helper");
var _xlsx_tag_helper2 = _interopRequireDefault(_xlsx_tag_helper);
var _xlsx_pattern_fill_helper = require("./xlsx_pattern_fill_helper");
var _xlsx_pattern_fill_helper2 = _interopRequireDefault(_xlsx_pattern_fill_helper);

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        "default": obj
    }
}
var xlsxFillHelper = {
    tryCreateTag: function(sourceObj) {
        var result = null;
        if ((0, _type.isDefined)(sourceObj)) {
            result = {
                patternFill: _xlsx_pattern_fill_helper2.default.tryCreateTag(sourceObj.patternFill)
            };
            if (xlsxFillHelper.isEmpty(result)) {
                result = null
            }
        }
        return result
    },
    tryCreateFillFromSimpleFormat: function() {
        var _ref = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {},
            backgroundColor = _ref.backgroundColor,
            patternStyle = _ref.patternStyle,
            patternColor = _ref.patternColor;
        if ((0, _type.isDefined)(backgroundColor) && !((0, _type.isDefined)(patternStyle) && (0, _type.isDefined)(patternColor))) {
            return {
                patternFill: {
                    patternType: "solid",
                    foregroundColor: {
                        rgb: backgroundColor
                    }
                }
            }
        } else {
            if ((0, _type.isDefined)(patternStyle) && (0, _type.isDefined)(patternColor)) {
                return {
                    patternFill: {
                        patternType: patternStyle,
                        foregroundColor: {
                            rgb: patternColor
                        },
                        backgroundColor: {
                            rgb: backgroundColor
                        }
                    }
                }
            }
        }
    },
    copySimpleFormat: function(source, target) {
        if (void 0 !== source.backgroundColor) {
            target.backgroundColor = source.backgroundColor
        }
        if (void 0 !== source.patternStyle) {
            target.patternStyle = source.patternStyle
        }
        if (void 0 !== source.patternColor) {
            target.patternColor = source.patternColor
        }
    },
    copy: function(source) {
        var result = null;
        if ((0, _type.isDefined)(source)) {
            result = {};
            if (void 0 !== source.patternFill) {
                result.patternFill = _xlsx_pattern_fill_helper2.default.copy(source.patternFill)
            }
        }
        return result
    },
    areEqual: function(leftTag, rightTag) {
        return xlsxFillHelper.isEmpty(leftTag) && xlsxFillHelper.isEmpty(rightTag) || (0, _type.isDefined)(leftTag) && (0, _type.isDefined)(rightTag) && _xlsx_pattern_fill_helper2.default.areEqual(leftTag.patternFill, rightTag.patternFill)
    },
    isEmpty: function(tag) {
        return !(0, _type.isDefined)(tag) || _xlsx_pattern_fill_helper2.default.isEmpty(tag.patternFill)
    },
    toXml: function(tag) {
        return _xlsx_tag_helper2.default.toXml("fill", {}, _xlsx_pattern_fill_helper2.default.toXml(tag.patternFill))
    }
};
exports.default = xlsxFillHelper;
